# UserS3KeysApi

## UserS3KeysApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                                                      | HTTP request                                 | Description                     |
| --------------------------------------------------------------------------- | -------------------------------------------- | ------------------------------- |
| [**um\_users\_s3keys\_delete**](#um_users_s3keys_delete)                    | **DELETE** /um/users/{userId}/s3keys/{keyId} | Delete S3 keys                  |
| [**um\_users\_s3keys\_find\_by\_key\_id**](#um_users_s3keys_find_by_key_id) | **GET** /um/users/{userId}/s3keys/{keyId}    | Retrieve user S3 keys by key ID |
| [**um\_users\_s3keys\_get**](#um_users_s3keys_get)                          | **GET** /um/users/{userId}/s3keys            | List user S3 keys               |
| [**um\_users\_s3keys\_post**](#um_users_s3keys_post)                        | **POST** /um/users/{userId}/s3keys           | Create user S3 keys             |
| [**um\_users\_s3keys\_put**](#um_users_s3keys_put)                          | **PUT** /um/users/{userId}/s3keys/{keyId}    | Modify a S3 Key by Key ID       |
| [**um\_users\_s3ssourl\_get**](#um_users_s3ssourl_get)                      | **GET** /um/users/{userId}/s3ssourl          | Retrieve S3 single sign-on URLs |

## **um\_users\_s3keys\_delete**

> um\_users\_s3keys\_delete(user\_id, key\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Delete S3 keys

Delete the specified user S3 key.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    key_id = 'key_id_example' # str | The unique ID of the S3 key.
    try:
        # Delete S3 keys
        api_instance.um_users_s3keys_delete(user_id, key_id)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3keys_delete: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **key\_id**             | **str**  | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

void (empty response body)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **um\_users\_s3keys\_find\_by\_key\_id**

> S3Key um\_users\_s3keys\_find\_by\_key\_id(user\_id, key\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Retrieve user S3 keys by key ID

Retrieve the specified user S3 key. The user ID is in the response body when the user is created, and in the list of the users, returned by GET. The key ID is in the response body when the S3 key is created, and in the list of all user S3 keys, returned by GET.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    key_id = 'key_id_example' # str | The unique ID of the S3 key.
    try:
        # Retrieve user S3 keys by key ID
        api_response = api_instance.um_users_s3keys_find_by_key_id(user_id, key_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3keys_find_by_key_id: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **key\_id**             | **str**  | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**S3Key**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3key)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **um\_users\_s3keys\_get**

> S3Keys um\_users\_s3keys\_get(user\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

List user S3 keys

List S3 keys by user ID. The user ID is in the response body when the user is created, and in the list of the users, returned by GET.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    try:
        # List user S3 keys
        api_response = api_instance.um_users_s3keys_get(user_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3keys_get: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**S3Keys**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3keys)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **um\_users\_s3keys\_post**

> S3Key um\_users\_s3keys\_post(user\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Create user S3 keys

Create an S3 key for the specified user. The user ID is in the response body when the user is created, and in the list of the users, returned by GET. A maximum of five keys per user can be generated.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    try:
        # Create user S3 keys
        api_response = api_instance.um_users_s3keys_post(user_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3keys_post: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**S3Key**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3key)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **um\_users\_s3keys\_put**

> S3Key um\_users\_s3keys\_put(user\_id, key\_id, s3\_key, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Modify a S3 Key by Key ID

Enables or disables the specified user S3 key.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    key_id = 'key_id_example' # str | The unique ID of the S3 key.
    s3_key = ionoscloud.S3Key() # S3Key | The modified S3 key.
    try:
        # Modify a S3 Key by Key ID
        api_response = api_instance.um_users_s3keys_put(user_id, key_id, s3_key)
        print(api_response)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3keys_put: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                                                           | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | ---------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**                                                                                        | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **key\_id**             | **str**                                                                                        | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **s3\_key**             | [**S3Key**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3key) | The modified S3 key.                                                                                                                                                                                                                                                                                                                                                                                                                     |                                |
| **pretty**              | **bool**                                                                                       | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                                                        | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                                                        | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**S3Key**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3key)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **um\_users\_s3ssourl\_get**

> S3ObjectStorageSSO um\_users\_s3ssourl\_get(user\_id, pretty=pretty, x\_contract\_number=x\_contract\_number)

Retrieve S3 single sign-on URLs

Retrieve S3 Object Storage single sign-on URLs for the the specified user. The user ID is in the response body when the user is created, and in the list of the users, returned by GET.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.UserS3KeysApi(api_client)
    user_id = 'user_id_example' # str | The unique ID of the user.
    try:
        # Retrieve S3 single sign-on URLs
        api_response = api_instance.um_users_s3ssourl_get(user_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling UserS3KeysApi.um_users_s3ssourl_get: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                    | Notes                          |
| ----------------------- | -------- | -------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **user\_id**            | **str**  | The unique ID of the user.                                                                                     |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                             | \[optional] \[default to True] |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed. | \[optional]                    |

#### Return type

[**S3ObjectStorageSSO**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/s3objectstoragesso)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json
